"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportedVariantCancer(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "alternate",
        "chromosome",
        "position",
        "reference",
        "reportEvents",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "reportEvents": reports_3_0_0.ReportEventCancer,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "org.gel.models.report.avro.ReportEventCancer": reports_3_0_0.ReportEventCancer,
            "org.gel.models.report.avro.ReportedVariantCancer": reports_3_0_0.ReportedVariantCancer,
        }

    __slots__ = [
        "alternate",
        "chromosome",
        "position",
        "reference",
        "reportEvents",
        "ClinVarIds",
        "CosmicIds",
        "IHP",
        "VAF",
        "additionalNumericVariantAnnotations",
        "additionalTextualVariantAnnotations",
        "cDNAchange",
        "comments",
        "commonAF",
        "dbSNPid",
        "depthAlternate",
        "depthReference",
        "proteinChange",
    ]

    def __init__(
        self,
        alternate,
        chromosome,
        position,
        reference,
        reportEvents,
        ClinVarIds=None,
        CosmicIds=None,
        IHP=None,
        VAF=None,
        additionalNumericVariantAnnotations=None,
        additionalTextualVariantAnnotations=None,
        cDNAchange=None,
        comments=None,
        commonAF=None,
        dbSNPid=None,
        depthAlternate=None,
        depthReference=None,
        proteinChange=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_3_0_0.ReportedVariantCancer model.

        :param alternate:
            alternate: Alternate Allele sequence, the same provided in vcf
        :type alternate: str
        :param chromosome:
            chromosome, named as: 1-22,X,Y,MT(other contigs name)
        :type chromosome: str
        :param position:
            position: Position 1-based
        :type position: int
        :param reference:
            reference: Reference Allele sequence, the same provided in vcf
        :type reference: str
        :param reportEvents:
        :type reportEvents: list[ReportEventCancer]
        :param ClinVarIds:
            variant ID in ClinVar
        :type ClinVarIds: None | list[str]
        :param CosmicIds:
            variant ID in Cosmic
        :type CosmicIds: None | list[str]
        :param IHP:
            Largest reference interrupted homopolymer length intersecting with the
            indel
        :type IHP: None | int
        :param VAF:
            Variant Allele Frequency
        :type VAF: None | double
        :param additionalNumericVariantAnnotations:
            For Example (Allele Frequency, sift, polyphen, mutationTaster, CADD.
            ..)
        :type additionalNumericVariantAnnotations: None | dict[str, float]
        :param additionalTextualVariantAnnotations:
            For example HGMD ID)
        :type additionalTextualVariantAnnotations: None | dict[str, str]
        :param cDNAchange:
            cDNA change, HGVS nomenclature (e.g.)
        :type cDNAchange: None | str
        :param comments:
            Comments
        :type comments: None | list[str]
        :param commonAF:
            AF in germline DBs
        :type commonAF: None | int
        :param dbSNPid:
            variant ID in dbSNP
        :type dbSNPid: None | str
        :param depthAlternate:
            Depth for Alternate Allele
        :type depthAlternate: None | int
        :param depthReference:
            Depth for Reference Allele
        :type depthReference: None | int
        :param proteinChange:
            protein change, HGVS nomenclature (e.g.)
        :type proteinChange: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
